Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.lib
Interface ExternalObjectModel

All Superinterfaces:
  Serializable

All Known Implementing Classes:
  DOM4JObjectModel, DOMEnvelope, DOMObjectModel, JDOMObjectModel, XOMObjectModel

    public interface ExternalObjectModel

extends Serializable

This interface must be implemented by any third-party object model that can be wrapped with a wrapper that implements the Saxon Object Model (the NodeInfo interface).

This interface is designed to enable advanced applications to implement and register new object model implementations that Saxon can then use without change. Although it is intended for external use, it cannot at this stage be considered part of the stable Saxon Public API. In particular, it is likely that the interface will grow by the addition of new methods.

For maximum integration, an object may extend `TreeModel` as well as implementing this interface. To implement `TreeModel`, it must supply a Builder; in effect this means that it will be possible to use the external object model for output as well as for input.

Method Summary
`Receiver` | `getDocumentBuilder(Result result)` Test whether this object model recognizes a particular kind of JAXP Result object, and if it does, return a Receiver that builds an instance of this data model from a sequence of events.
`String` | `getIdentifyingURI()` Get the URI of the external object model as used in the JAXP factory interfaces for obtaining an XPath implementation
`JPConverter` | `getJPConverter(Class sourceClass)` Get a converter from values in the external object model to XPath values.
`PJConverter` | `getNodeListCreator(Object node)` Get a converter that converts a sequence of XPath nodes to this model's representation of a node list.
`PJConverter` | `getPJConverter(Class targetClass)` Get a converter from XPath values to values in the external object model
`boolean` | `sendSource(Source source, Receiver receiver)` Test whether this object model recognizes a particular kind of JAXP Source object, and if it does, send the contents of the document to a supplied Receiver, and return true.
`NodeInfo` | `unravel(Source source, Configuration config)` Wrap or unwrap a node using this object model to return the corresponding Saxon node.

Method Detail

### getIdentifyingURI

    String getIdentifyingURI()

  Get the URI of the external object model as used in the JAXP factory interfaces for obtaining an XPath implementation

  Returns:
    the URI used to identify this object model in the JAXP XPath factory mechanism.

### getPJConverter

    PJConverter getPJConverter(Class targetClass)

  Get a converter from XPath values to values in the external object model

  Parameters:
    `targetClass` - the required class of the result of the conversion. If this class represents a node or list of nodes in the external object model, the method should return a converter that takes a native node or sequence of nodes as input and returns a node or sequence of nodes in the external object model representation. Otherwise, it should return null.
  Returns:
    a converter, if the targetClass is recognized as belonging to this object model; otherwise null

### getJPConverter

    JPConverter getJPConverter(Class sourceClass)

  Get a converter from values in the external object model to XPath values.

  Parameters:
    `sourceClass` - the class (static or dynamic) of values to be converted
  Returns:
    a converter, if the sourceClass is recognized as belonging to this object model; otherwise null

### getNodeListCreator

    PJConverter getNodeListCreator(Object node)

  Get a converter that converts a sequence of XPath nodes to this model's representation of a node list.

  This method is primarily for the benefit of DOM, which uses its own NodeList class to represent collections of nodes. Most other object models use standard Java collection objects such as java.util.List

  Parameters:
    `node` - an example of the kind of node used in this model
  Returns:
    if the model does not recognize this node as one of its own, return null. Otherwise return a PJConverter that takes a list of XPath nodes (represented as NodeInfo objects) and returns a collection of nodes in this object model

### getDocumentBuilder

    Receiver getDocumentBuilder(Result result)
                                throws XPathException

  Test whether this object model recognizes a particular kind of JAXP Result object, and if it does, return a Receiver that builds an instance of this data model from a sequence of events. If the Result is not recognised, return null.

  Parameters:
    `result` - a JAXP result object
  Returns:
    a Receiver that writes to that result, if available; or null otherwise
  Throws:
    `XPathException` - if any failure occurs

### sendSource

    boolean sendSource(Source source,
                       Receiver receiver)
                       throws XPathException

  Test whether this object model recognizes a particular kind of JAXP Source object, and if it does, send the contents of the document to a supplied Receiver, and return true. Otherwise, return false.

  Parameters:
    `source` - a JAXP Source object
    `receiver` - the Receiver that is to receive the data from the Source
  Returns:
    true if the data from the Source has been sent to the Receiver, false otherwise
  Throws:
    `XPathException` - if any failure occurs

### unravel

    NodeInfo unravel(Source source,
                     Configuration config)

  Wrap or unwrap a node using this object model to return the corresponding Saxon node. If the supplied source does not belong to this object model, return null

  Parameters:
    `source` - a JAXP Source object
    `config` - the Saxon configuration
  Returns:
    a NodeInfo corresponding to the Source, if this can be constructed; otherwise null

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.